if(!isFunction(addExtraResource))
	exec("./extraResources.cs");

//prefs
if(isFile("Add-Ons/System_BlocklandGlass/image/icon/glasslogo.png"))
	%defaultGlassEnableState = true;
else
	%defaultGlassEnableState = false;

if(isFile("Add-Ons/System_ReturnToBlockland/images/icons/rtblogo.png"))
	%defaultRTBEnableState = true;
else
	%defaultRTBEnableState = false;

if($Pref::Server::ChatEmotes::EnableBlocklandUI $= "")
	$Pref::Server::ChatEmotes::EnableBlocklandUI = true;
if($Pref::Server::ChatEmotes::EnableBlocklandCI $= "")
	$Pref::Server::ChatEmotes::EnableBlocklandCI = true;
if($Pref::Server::ChatEmotes::EnableGlassEmotes $= "")
	$Pref::Server::ChatEmotes::EnableGlassEmotes = %defaultGlassEnableState;
if($Pref::Server::ChatEmotes::EnableRTBEmotes $= "")
	$Pref::Server::ChatEmotes::EnableRTBEmotes = %defaultRTBEnableState;

//rtb prefs
if($RTB::Hooks::ServerControl)
{
	RTB_registerPref("Enable Default Blockland UI Emotes",		"Chat Emotes - Emote Support",	"$Pref::Server::ChatEmotes::EnableBlocklandUI",		"bool",		"Server_ChatEmotes",	true,						false,	false,	false);
	RTB_registerPref("Enable Default Blockland CI Emotes",		"Chat Emotes - Emote Support",	"$Pref::Server::ChatEmotes::EnableBlocklandCI",		"bool",		"Server_ChatEmotes",	true,						false,	false,	false);
	RTB_registerPref("Enable Blockland Glass Icon Emotes",		"Chat Emotes - Emote Support",	"$Pref::Server::ChatEmotes::EnableGlassEmotes",		"bool",		"Server_ChatEmotes",	%defaultGlassEnableState,	false,	false,	false);
	RTB_registerPref("Enable Return to Blockland Icon Emotes",	"Chat Emotes - Emote Support",	"$Pref::Server::ChatEmotes::EnableRTBEmotes",		"bool",		"Server_ChatEmotes",	%defaultRTBEnableState,		false,	false,	false);
}

function loadChatEmoteAddOns()
{
	%addonPattern = "Add-Ons/ChatEmotes_*/description.txt";
	
	%descriptionFile = findFirstFile(%addonPattern);
	while(%descriptionFile !$= "")
	{
		$ChatEmotes::AmountAddons++;
		$ChatEmotes::Addon[$ChatEmotes::AmountAddons] = %descriptionFile;
		if($ChatEmotes::AmountAddons != 1 && $ChatEmotes::Addon[$ChatEmotes::AmountAddons] $= $ChatEmotes::Addon1)
			break;
		
		%descriptionFile = findNextFile(%addonPattern);
	}
	
	for(%a = 0; %a <= $ChatEmotes::AmountAddons; %a++)
	{
		if(%a != 1 && $ChatEmotes::Addon[%a] $= $ChatEmotes::Addon1)
			break;
		
		if(!isFunction(addExtraResource))
		{
			error("addExtraResource function is missing - unable to create emotes");
			break;
		}
		
		if($ChatEmotes::Addon[%a] !$= "")
			createChatEmotes($ChatEmotes::Addon[%a]);
	}
}

function createChatEmotes(%addonFile)
{
	%addonFile = strReplace(%addonFile, "/description.txt", "");
	%pattern = %addonFile @ "/*.png";
	%addonFile = strReplace(%addonFile, "Add-Ons/", "");
	echo("Adding chat emotes from " @ %addonFile);
	%addonFile = strReplace(%addonFile, "ChatEmotes_", "");
	
	for(%file = findFirstFile(%pattern); %file !$= ""; %file = findNextFile(%pattern))
	{
		%base = fileBase(%file);

		if(ServerGroup.addedExtraResource[%file] == true)
		{
			warn(%base @ " already exists");
			continue;
		}
		
		if(isFunction(addExtraResource))
			addExtraResource(%file);
		else
		{
			error("addExtraResource function is missing - unable to create emotes");
			break;
		}

		if(ServerGroup.addedExtraResource[%file] == true)
		{
			%base = ":" @ %base @ ":";
			$ChatEmotes::Path[%base] = %file;
			$ChatEmotes::AmountEmotes[%addonFile]++;
			%amountEmotes = $ChatEmotes::AmountEmotes[%addonFile];
			$ChatEmotes::Emote[%addonFile, %amountEmotes] = %base;
		}
		else
			warn(%base @ " couldn't be created for some reason.");
	}
	
	warn("created " @ $ChatEmotes::AmountEmotes[%addonFile] @ " chat emotes");
	echo("");
}
echo("");
loadChatEmoteAddOns();

if(isPackage("chatEmotesServer"))
	deactivatePackage("chatEmotesServer");
package chatEmotesServer
{
	function serverCmdMessageSent(%client, %text) //edit of blockland source code
	{
		if(strPos(%text, ":") >= 0) //if no potential emotes are detected, simply parent to normal chat
		{
			//repeat check
			%trimText = trim(%text);
			if(%client.lastChatText $= %trimText)
			{
				%chatDelta = (getSimTime() - %client.lastChatTime) / getTimeScale();
				if(%chatDelta < 15000.0)
				{
					%client.spamMessageCount = $SPAM_MESSAGE_THRESHOLD;
					messageClient(%client, '', '\c5Do not repeat yourself.');
				}
			}
			%client.lastChatTime = getSimTime();
			%client.lastChatText = %trimText;
			
			//player talk animation
			%player = %client.Player;
			if(isObject(%player))
			{
				%player.playThread(3, talk);
				%player.schedule(strlen(%text) * 50.0, playThread, 3, root);
			}
			
			//text filtering
			%text = chatWhiteListFilter(%text);
			%text = StripMLControlChars(%text);
			%text = trim(%text);
			if(strlen(%text) <= 0.0)
				return;
			if($Pref::Server::MaxChatLen > 0.0)
			{
				if(strlen(%text) >= $Pref::Server::MaxChatLen)
					%text = getSubStr(%text, 0, $Pref::Server::MaxChatLen);
			}
			
			//links
			%protocol = "http://";
			%protocolLen = strlen(%protocol);
			%urlStart = strpos(%text, %protocol);
			if(%urlStart == -1.0)
			{
				%protocol = "https://";
				%protocolLen = strlen(%protocol);
				%urlStart = strpos(%text, %protocol);
			}
			if(%urlStart == -1.0)
			{
				%protocol = "ftp://";
				%protocolLen = strlen(%protocol);
				%urlStart = strpos(%text, %protocol);
			}
			if(%urlStart != -1.0)
			{
				%urlEnd = strpos(%text, " ", %urlStart + 1.0);
				%skipProtocol = 0;
				if(%protocol $= "http://")
					%skipProtocol = 1;
				if(%urlEnd == -1.0)
				{
					%fullUrl = getSubStr(%text, %urlStart, strlen(%text) - %urlStart);
					%url = getSubStr(%text, %urlStart + %protocolLen, strlen(%text) - %urlStart - %protocolLen);
				}
				else
				{
					%fullUrl = getSubStr(%text, %urlStart, %urlEnd - %urlStart);
					%url = getSubStr(%text, %urlStart + %protocolLen, %urlEnd - %urlStart - %protocolLen);
				}
				if(strlen(%url) > 0.0)
				{
					%url = strreplace(%url, "<", "");
					%url = strreplace(%url, ">", "");
					if (%skipProtocol)
						%newText = strreplace(%text, %fullUrl, "<a:" @ %url @ ">" @ %url @ "</a>\c6");
					else
						%newText = strreplace(%text, %fullUrl, "<a:" @ %protocol @ %url @ ">" @ %url @ "</a>\c6");
					%text = %newText;
				}
			}
			
			//etard
			if($Pref::Server::ETardFilter)
			{
				if(!chatFilter(%client, %text, $Pref::Server::ETardList, '\c5This is a civilized game.  Please use full words.'))
					return;
			}
			
			//apply the emote bitmaps - this is the only thing we add
			%text = peReplace(%text, "\c6");
			//the reason we dont parent and instead edit the original code is because the normal function removes bitmaps
			
			//send the message
			chatMessageAll(%client, '\c7%1\c3%2\c7%3\c6: %4', %client.clanPrefix, %client.getPlayerName(), %client.clanSuffix, %text);
			echo(%client.getSimpleName() @ ": " @ %text);
		}
		else
			parent::serverCmdMessageSent(%client, %text);
	}
	
	//we intentionally dont touch team chat
};
activatePackage("chatEmotesServer");

function peReplace(%str, %color)
{
	if(strPos(%str, ":") < 0) //we change the syntax of the original mod: it required you do something like [](/emotename), which is w e i r d
		return %str;

	%new = "";
	while((%pos = strPos(%str, ":")) >= 0)
	{
		%new = %new @ getSubStr(%str, 0, %pos);
		%str = getSubStr(%str, %pos + 1, strLen(%str));
		%end = strPos(%str, ":");
		
		if(%end < 1)
		{
			%new = %new @ ":" @ getSubStr(%str, 0, 1);
			%str = getSubStr(%str, 1, strLen(%str));
			continue;
		}

		%code = getSubStr(":" @ %str, 0, %end + 2);
		%str = getSubStr(%str, %end + 1, strLen(%str));
		%newCheck = %new @ peParse(%code, %color);
		
		if(strLen(%newCheck) + strLen(%str) > 255)
		{
			%new = %new @ %code;
			continue;
		}
		
		%new = %newCheck;
	}

	%new = %new @ %str;
	return %new;
}

function peParse(%code, %color)
{
	//check for special cases
	%path = "";
	if(getSubStr(%code, 1, 5) $= "glass" && $Pref::Server::ChatEmotes::EnableGlassEmotes) //glass icons support
		%path = "Add-Ons/System_BlocklandGlass/image/icon/" @ getSubStr(%code, 6, strLen(%code) - 7) @ ".png";
	else if(getSubStr(%code, 1, 3) $= "rtb" && $Pref::Server::ChatEmotes::EnableRTBEmotes) //rtb icons support
		%path = "Add-Ons/System_ReturnToBlockland/images/icons/" @ getSubStr(%code, 4, strLen(%code) - 5) @ ".png";
	else if(getSubStr(%code, 1, 2) $= "ci" && $Pref::Server::ChatEmotes::EnableBlocklandCI) //ci icons support with some hard coded stuff
	{
		if(%code $= ":ciarrow:") //arrow ci
			%path = "Add-Ons/Weapon_Bow/CI_arrow.png";
		else if(%code $= ":cigun:") //gun ci
			%path = "Add-Ons/Weapon_Gun/CI_gun.png";
		else if(%code $= ":ci2guns:") //2guns ci
			%path = "Add-Ons/Weapon_Guns_Akimbo/CI_2guns.png";
		else if(%code $= ":cirocket:") //rocket ci
			%path = "Add-Ons/Weapon_Rocket_Launcher/CI_rocket.png";
		else if(%code $= ":cirocketradius:") //rocket radius ci
			%path = "Add-Ons/Weapon_Rocket_Launcher/CI_rocketRadius.png";
		else if(%code $= ":cispear:") //spear ci
			%path = "Add-Ons/Weapon_Spear/CI_spear.png";
		else if(%code $= ":cispearradius:") //spear radius ci
			%path = "Add-Ons/Weapon_Spear/CI_spearRadius.png";
		else if(%code $= ":cisword:") //sword ci
			%path = "Add-Ons/Weapon_Sword/CI_sword.png";
		else if(%code $= ":ciball:") //cannon ci
			%path = "Add-Ons/Vehicle_Pirate_Cannon/ball.png";
		else if(%code $= ":ciballradius:") //cannon radius ci
			%path = "Add-Ons/Vehicle_Pirate_Cannon/ballradius.png";
		else if(%code $= ":cifire:") //fire ci
			%path = "Add-Ons/GameMode_Blockheads_Ruin_Xmas/CI_Fire.png";
		else if(%code $= ":cimelee:") //melee ci
			%path = "Add-Ons/Bot_Hole/CI_Melee.png";
		else //if it's none of the above, we check in base/client/ui/ci
			%path = "base/client/ui/ci/" @ getSubStr(%code, 3, strLen(%code) - 4) @ ".png";
	}
	else if(getSubStr(%code, 1, 2) $= "ui" && $Pref::Server::ChatEmotes::EnableBlocklandUI) //ui icons support with some hard coded stuff
	{
		if(%code $= ":uilag:") //lag
			%path = "base/client/ui/lagIcon.png";
		else //if it's none of the above, we check in base/client/ui/plantErrors_small
			%path = "base/client/ui/plantErrors_small/plantError_" @ getSubStr(%code, 3, strLen(%code) - 4) @ ".png";
	}
	
	//catch if no special case occured
	if(!isFile(%path))
		%path = $ChatEmotes::Path[%code];
	
	//make sure its real
	if(%path $= "")
		return %code;
	if(!isFile(%path))
		return %code;

	if(%color $= "")
		%color = "\c6";
	
	return "<bitmap:" @ %path @ ">" @ %color;
}

function serverCmdListEmotes(%client, %addon)
{
	if(%addon $= "")
	{
		messageClient(%client, '', "\c6Type \c3/ListEmotes (groupname)\c6, replacing \c3(groupname)\c6 with one of the words below:");
		if($Pref::Server::ChatEmotes::EnableBlocklandUI)
			messageClient(%client, '', "\c6- \c3Blockland_UI");
		if($Pref::Server::ChatEmotes::EnableBlocklandCI)
			messageClient(%client, '', "\c6- \c3Blockland_CI");
		if($Pref::Server::ChatEmotes::EnableGlassEmotes)
			messageClient(%client, '', "\c6- \c3Blockland_Glass");
		if($Pref::Server::ChatEmotes::EnableRTBEmotes)
			messageClient(%client, '', "\c6- \c3Return_to_Blockland");
		for(%a = 0; %a <= $ChatEmotes::AmountAddons; %a++)
		{
			if(%a != 1 && $ChatEmotes::Addon[%a] $= $ChatEmotes::Addon1)
				break;
			
			if($ChatEmotes::Addon[%a] !$= "")
			{
				%addonName = $ChatEmotes::Addon[%a];
				%addonName = strReplace(%addonName, "/description.txt", "");
				%addonName = strReplace(%addonName, "Add-Ons/ChatEmotes_", "");
				messageClient(%client, '', "\c6- \c3" @ %addonName);
			}
		}
		messageClient(%client, '', "\c6Type \c3/ListEmotes (groupname)\c6, replacing \c3(groupname)\c6 with one of the words above.");
	} //we hand-build some of the below lists because the players shouldnt be removing/adding images to their internal files.
	else if(%addon $= "Blockland_UI" && $Pref::Server::ChatEmotes::EnableBlocklandUI)
	{
		messageClient(%client, '', "\c6These are valid emotes found in \c3Blockland_UI\c6.");
		messageClient(%client, '', "\c6- \c3:uiBuried:\c6 = <bitmap:base/client/ui/plantErrors_small/plantError_buried.png>");
		messageClient(%client, '', "\c6- \c3:uiFloat:\c6 = <bitmap:base/client/ui/plantErrors_small/plantError_float.png>");
		messageClient(%client, '', "\c6- \c3:uiFlood:\c6 = <bitmap:base/client/ui/plantErrors_small/plantError_flood.png>");
		messageClient(%client, '', "\c6- \c3:uiLimit:\c6 = <bitmap:base/client/ui/plantErrors_small/plantError_limit.png>");
		messageClient(%client, '', "\c6- \c3:uiOverlap:\c6 = <bitmap:base/client/ui/plantErrors_small/plantError_overlap.png>");
		messageClient(%client, '', "\c6- \c3:uiStuck:\c6 = <bitmap:base/client/ui/plantErrors_small/plantError_stuck.png>");
		messageClient(%client, '', "\c6- \c3:uiTeams:\c6 = <bitmap:base/client/ui/plantErrors_small/plantError_teams.png>");
		messageClient(%client, '', "\c6- \c3:uiTooFar:\c6 = <bitmap:base/client/ui/plantErrors_small/plantError_toofar.png>");
		messageClient(%client, '', "\c6- \c3:uiTooloud:\c6 = <bitmap:base/client/ui/plantErrors_small/plantError_tooLoud.png>");
		messageClient(%client, '', "\c6- \c3:uiUnstable:\c6 = <bitmap:base/client/ui/plantErrors_small/plantError_unstable.png>");
		messageClient(%client, '', "\c6- \c3:uiLag:\c6 = <bitmap:base/client/ui/lagIcon.png>");
		messageClient(%client, '', "\c6These are valid emotes found in \c3Blockland_UI\c6.");
	}
	else if(%addon $= "Blockland_CI" && $Pref::Server::ChatEmotes::EnableBlocklandUI)
	{
		messageClient(%client, '', "\c6These are valid emotes found in \c3Blockland_CI\c6.");
		messageClient(%client, '', "\c6- \c3:ciBlueRibbon:\c6 = <bitmap:base/client/ui/ci/blueRibbon.png>");
		messageClient(%client, '', "\c6- \c3:ciBomb:\c6 = <bitmap:base/client/ui/ci/bomb.png>");
		messageClient(%client, '', "\c6- \c3:ciCar:\c6 = <bitmap:base/client/ui/ci/car.png>");
		messageClient(%client, '', "\c6- \c3:ciCarExplosion:\c6 = <bitmap:base/client/ui/ci/carExplosion.png>");
		messageClient(%client, '', "\c6- \c3:ciCrater:\c6 = <bitmap:base/client/ui/ci/crater.png>");
		messageClient(%client, '', "\c6- \c3:ciGeneric:\c6 = <bitmap:base/client/ui/ci/generic.png>");
		messageClient(%client, '', "\c6- \c3:ciHammer:\c6 = <bitmap:base/client/ui/ci/hammer.png>");
		messageClient(%client, '', "\c6- \c3:ciSkull:\c6 = <bitmap:base/client/ui/ci/skull.png>");
		messageClient(%client, '', "\c6- \c3:ciSplat:\c6 = <bitmap:base/client/ui/ci/splat.png>");
		messageClient(%client, '', "\c6- \c3:ciStar:\c6 = <bitmap:base/client/ui/ci/star.png>");
		messageClient(%client, '', "\c6- \c3:ciTrophy:\c6 = <bitmap:base/client/ui/ci/trophy.png>");
		messageClient(%client, '', "\c6- \c3:ciArrow:\c6 = <bitmap:Add-Ons/Weapon_Bow/CI_arrow.png>");
		messageClient(%client, '', "\c6- \c3:ciGun:\c6 = <bitmap:Add-Ons/Weapon_Gun/CI_gun.png>");
		messageClient(%client, '', "\c6- \c3:ci2Guns:\c6 = <bitmap:Add-Ons/Weapon_Guns_Akimbo/CI_2guns.png>");
		messageClient(%client, '', "\c6- \c3:ciRocket:\c6 = <bitmap:Add-Ons/Weapon_Rocket_Launcher/CI_rocket.png>");
		messageClient(%client, '', "\c6- \c3:ciRocketRadius:\c6 = <bitmap:Add-Ons/Weapon_Rocket_Launcher/CI_rocketRadius.png>");
		messageClient(%client, '', "\c6- \c3:ciSpear:\c6 = <bitmap:Add-Ons/Weapon_Spear/CI_spear.png>");
		messageClient(%client, '', "\c6- \c3:ciSpearRadius:\c6 = <bitmap:Add-Ons/Weapon_Spear/CI_spearRadius.png>");
		messageClient(%client, '', "\c6- \c3:ciSword:\c6 = <bitmap:Add-Ons/Weapon_Sword/CI_sword.png>");
		messageClient(%client, '', "\c6- \c3:ciBall:\c6 = <bitmap:Add-Ons/Vehicle_Pirate_Cannon/ball.png>");
		messageClient(%client, '', "\c6- \c3:ciBallRadius:\c6 = <bitmap:Add-Ons/Vehicle_Pirate_Cannon/ballradius.png>");
		messageClient(%client, '', "\c6- \c3:ciFire:\c6 = <bitmap:Add-Ons/GameMode_Blockheads_Ruin_Xmas/CI_Fire.png>");
		messageClient(%client, '', "\c6- \c3:ciMelee:\c6 = <bitmap:Add-Ons/Bot_Hole/CI_Melee.png>");
		messageClient(%client, '', "\c6These are valid emotes found in \c3Blockland_CI\c6.");
	}
	else if(%addon $= "Blockland_Glass" && $Pref::Server::ChatEmotes::EnableGlassEmotes)
	{
		messageClient(%client, '', "\c6There are way too many usable emotes to list for \c3Blockland_Glass\c3.");
		messageClient(%client, '', "\c6Everything inside \c3System_BlocklandGlass/image/icon/\c6 is a usable emote.");
		messageClient(%client, '', "\c6However, you must have Blockland Glass' icons to see them.");
		messageClient(%client, '', "\c6The syntax for these icons are \c3:glass(IMAGENAME):\c6.");
		messageClient(%client, '', "\c6Example: \c3:glassglasslogo:\c6 = <bitmap:Add-Ons/System_BlocklandGlass/image/icon/glasslogo.png>");
		messageClient(%client, '', "\c6If you can't see that image, you don't have Blockland Glass' icons.");
	}
	else if(%addon $= "Return_to_Blockland" && $Pref::Server::ChatEmotes::EnableRTBEmotes)
	{
		messageClient(%client, '', "\c6There are way too many usable emotes to list for \c3Return_to_Blockland\c3.");
		messageClient(%client, '', "\c6Everything inside \c3System_ReturnToBlockland/images/icons/\c6 is a usable emote.");
		messageClient(%client, '', "\c6However, you must have Return To Blockland's icons to see them.");
		messageClient(%client, '', "\c6The syntax for these icons are \c3:rtb(IMAGENAME):\c6.");
		messageClient(%client, '', "\c6Example: \c3:rtbrtblogo:\c6 = <bitmap:Add-Ons/System_ReturnToBlockland/images/icons/rtblogo.png>");
		messageClient(%client, '', "\c6If you can't see that image, you don't have Return To Blockland's icons.");
	}
	else if(isFile("Add-Ons/ChatEmotes_" @ %addon @ "/description.txt"))
	{
		messageClient(%client, '', "\c6These are valid emotes found in \c3" @ %addon @ "\c6.");
		for(%a = 0; %a <= $ChatEmotes::AmountEmotes[%addon]; %a++)
		{
			%emote = $ChatEmotes::Emote[%addon, %a];
			
			if(%a != 1 && %emote $= $ChatEmotes::Emote[%addon, 1])
				break;
			
			if(%emote !$= "")
				messageClient(%client, '', "\c6- \c3" @ %emote @ "\c6 = <bitmap:" @ $ChatEmotes::Path[%emote] @ ">");
		}
		messageClient(%client, '', "\c6These are valid emotes found in \c3" @ %addon @ "\c6.");
	}
	else
	{
		messageClient(%client, '', "\c6Group not found.");
		return;
	}
	
	messageClient(%client, '', "\c6Press \c3PageUp\c6 or \c3PageDown\c6 to scroll chat. Server is running \c3Chat Emotes v9\c6.");
}

function serverCmdEmoteList(%client, %addon)
{
	serverCmdListEmotes(%client, %addon);
}

function serverCmdChatEmoteList(%client, %addon)
{
	serverCmdListEmotes(%client, %addon);
}

function serverCmdListChatEmotes(%client, %addon)
{
	serverCmdListEmotes(%client, %addon);
}